const parser = require('typescript-eslint-parser');
const parseForESLint = parser.parseForESLint;
const visitorKeys = require('eslint-visitor-keys');
const babelVisitorKeys = require('@babel/types').VISITOR_KEYS;

// Monkey-patch: override typescript-eslint-parser's visitorKeys
// issue: https://github.com/eslint/typescript-eslint-parser/issues/514
parser.parseForESLint = function() {
  const result = parseForESLint.apply(this, arguments);
  result.visitorKeys = babelVisitorKeys;
  return result;
};

module.exports = {
  parser: 'typescript-eslint-parser',
  plugins: [
    'typescript',
  ],
  rules: {
    'no-undef': 'off',
    'no-unused-vars': 'off',
    'no-useless-constructor': 'off',
    'no-dupe-class-members': 'off',
    'no-use-before-define': 'off',
    'typescript/adjacent-overload-signatures': 'error',
    'typescript/class-name-casing': 'error',
    'typescript/no-unused-vars': 'error'
  }
};
